import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Ciguena es el actor principal en el mundo.
 * 
 * @Maria Susana Acuna Rodriguez 
 * @version May 31, 2010
 */
public class Ciguena  extends AnimatedActor
{
/* Variables de la clase Ciguena, las cuales fundamentan el correcto funcionamiento de este actor.
 * 
 */

    boolean volteado=false;
    int vidas=3;
    int puntos;
    private Score pun;
    private Score lifes=new Score("LIFES:"+vidas);
    private Vida vd1=new Vida(),vd2=new Vida(), vd3=new Vida(),vd4=new Vida();
    private Corazon c=new Corazon();
    boolean yaPusoVida= false;
    boolean vidasFuera=false;
    boolean extra=false;
    private Bebe bb;
    private Bebe2 bb2;
    boolean yaPusoBebe=false;
    int colorB=5,colorB2=5;
    private Casa c0,c1,c2,c3,c4;
    boolean yaPuseCasa=false;
    int nc0,nc1,nc2,nc3,nc4;
    int contador=0, contador2=0;
    int numeroBebes=0;
    boolean yaAgarreBebe=false;
    boolean borrarBebes=false;
    int numeroMaximoBebes=6;
    boolean cambia=false;
    boolean yaDejeBebe=false;
    boolean cual=false;
    boolean primero=false;
    int nivel;
   
    /** Constructor de la clase Ciguena, no recibe parametros y manda llamar al constructor de su Super Clase
     * e inicializa varias variables de instancia como las vidas, y crea un objeto nuevo Score
     */
     
    public Ciguena(int vi, int niv,int pts)
    {
        super("ciguena",".png",8);
        vidas=vi;
        nivel=niv;
        puntos=pts;
        pun= new Score("SCORE:"+puntos);

    }
    /** Actuacin de la Ciguea en el mundo
     * 
     * 
     */
    public void act() 
    {
        actuaCiguena();
    }
    /*
     *Aqui se muestra toda la actuacion de la ciguena en el mundo
     *incluyendo todas y cada una de las validaciones correctas para poder jugar, estas validaciones son muy imporntantes para poder interactuar con el 
     *mundo.
     *No recibe parametros.
     */
    public void actuaCiguena()
    {
        World wd= getWorld();
        wd.addObject(pun,150,3);
        wd.addObject(lifes,145,7);
        agregaCasas();
        if(!yaPusoBebe)
            ChecaPonerBebes(cual);
        colocaVidaExtra(wd);  
         agregaVidasFuera(wd);
         Actor baby=getOneIntersectingObject(Bebe.class);
         Actor baby2=getOneIntersectingObject(Bebe2.class);
         Actor casa=getOneIntersectingObject(Casa.class);
         siChocaVidaExtra();
         siChocaCuervo();

            
            if(numeroBebes==2&&baby2!=null)
            {
            ((Mundo)getWorld()).remueveBebes();
            borrarBebes=true;
            numeroBebes=0;
            yaAgarreBebe=false;
            restar(100);
            pun.setText("SCORE: "+puntos);
            colorB=colorB2=5;
            restaVida();
        }
        if(numeroBebes==2&&baby!=null)
            {
            ((Mundo)getWorld()).remueveBebes();
            borrarBebes=true;
            numeroBebes=0;
            yaAgarreBebe=false;
            restar(100);
            pun.setText("SCORE: "+puntos);
            colorB=colorB2=5;
            restaVida();
        }
       if(baby!=null&&!yaAgarreBebe)
         if(cambiaImagen(colorB))
            wd.removeObject(baby);
                          
          if(baby2!=null&&!yaAgarreBebe&&!borrarBebes)  
          
               if(cambiaImagen(colorB2))
                   wd.removeObject(baby2);
                   //yaAgarreBebe=false;
                
                                         
            if(casa!=null&&!yaDejeBebe&&!borrarBebes)
            {
              revalida();
                if(cual)
                            checa(colorB);
                 else 
                            checa(colorB2);
                // revalida();
                                       
            }

        super.act();
        if(!yaPerdio())
        {
         movimientos(wd);
         super.act();
        }   
        else
        
        perder();
    
    contador++;

    if(contador==115)
    {
    contador=0;
    yaPusoBebe=false;
    Greenfoot.playSound("cuervo.wav");
   if(numeroBebes==0)
   borrarBebes=false;
}
if(numeroMaximoBebes==0&&!yaAgarreBebe)
{
if(!checaNivel())
ganaste();
else
siguieneteNivel();
}    
        }
        
/** Llama al metodo perder del mundo.
 * 
 */     
public void perder()
{
  ((Mundo)getWorld()).gameOver();
}
/** Llama al metodo ganar del mundo.
 * 
 */   
public void ganaste()
{
((Mundo)getWorld()).winner(puntos);
}
/** yaPerdio checa el numero de vidas y retorna un valor booleano para confirmar respuesta
 * 
 */
public boolean yaPerdio()
{
  boolean ret=false;
  if(vidas==0 || numeroBebes==3)
    ret=true;
   return ret;
}
    
    /**regresa el numero de vidas que le quedan al jugador
     * 
     */
public int cuantasVidas()
{
    return vidas;
}
    
    /** Coloca una casa dentro del mundo dependiendo del identificador de la misma.
     * @param i es el identificador que le damos a la casa para que sea creada en el mundo y se le asigne un color.
     * @param ca es el objeto de la clase Casa que se creara en el mundo.
     */

    public void agregaCasa(int i, Casa ca)
    {
        World wd= getWorld();
        int sp=15;
        switch(i)
        {
            case 0:
                c0 = new Casa(i);
                wd.addObject(c0,sp,97);
                break;
                
            case 1:
                 c1 = new Casa(i);
                wd.addObject(c1,sp*3+2,97);
                break;
                
            case 2:
                 c2 = new Casa(i);
                wd.addObject(c2,sp*5+2,97);
                break;
            case 3:
                 c3 = new Casa(i);
                wd.addObject(c3,sp*7+2,97);
                break;
            case 4:
                 c4 = new Casa(i);
                wd.addObject(c4,sp*9,97);
                break;
            
            }
        
    }
    
    /** la Funcin checa Bebe se realiza para poder identificar en que casa fue entregado, partiendo de las posiciones en las que se
     * encuentran las casas en el mundo, tambin actualiza el Score del jugador dependiendo de la accin que realizo y cambia la variable
     *colorB = 5 para que ste no sea un nmero vlido.
     */
public void checa(int cb)
    {
       int x,y;
       x=getX();
       y=getY();
       if(colorB<5||colorB2<5)
       {
        if((x>=0)&&(x<=30) && (y<99))
        {
           if(cb==nc0)
            {
               puntos=puntos+250;
               pun.setText("SCORE: "+puntos);
               yaAgarreBebe=false;
               Greenfoot.playSound("yes.wav");
            }
            else
            {
            restar(50);
            pun.setText("SCORE: "+puntos);
            yaAgarreBebe=false;
        }
        }
        if((x>=31)&&(x<=61) && (y<99))
       {
           if(cb==nc1)
           {
               puntos=puntos+250;
               pun.setText("SCORE: "+puntos);
               yaAgarreBebe=false;
               Greenfoot.playSound("yes.wav");
            }
            else
            {
            restar(50);
            pun.setText("SCORE: "+puntos);
            yaAgarreBebe=false;
        }
        }
        if((x>=62)&&(x<=92) && y<99)
       {
           if(cb==nc2)
           {
               puntos=puntos+250;
               pun.setText("SCORE: "+puntos);
               yaAgarreBebe=false;
               Greenfoot.playSound("yes.wav");
            }
            else
            {
            restar(50);
            pun.setText("SCORE: "+puntos);
            yaAgarreBebe=false;
        }
        }
         if((x>=93)&&(x<=123) && y<99)
       {
           if(cb==nc3)
           {
               puntos=puntos+250;
               pun.setText("SCORE: "+puntos);
               yaAgarreBebe=false;
               Greenfoot.playSound("yes.wav");
            }
            else
            {
            restar(50);
            pun.setText("SCORE: "+puntos);
            yaAgarreBebe=false;
        }
        }   
        if(x>=124 && y<99)
       {
           if(cb==nc4)
           {
               puntos=puntos+250;
               pun.setText("SCORE: "+puntos);
               yaAgarreBebe=false;
               Greenfoot.playSound("yes.wav");
            }
            else
            {
            restar(50);
            pun.setText("SCORE: "+puntos);
            yaAgarreBebe=false;
        }
        }
   }
    colorB=5;
    yaDejeBebe=true;
    super.cambiaImagen("ciguena",".png",8);
    yaAgarreBebe=false;
    volteado=false;
    //puntos=puntos-50;
}

/**
 * Metodo que hace la tarea de checar el numero de Bebes que hay actualmente en el mundo
 */
public int checaNumeroBebes()
{
    return numeroBebes;
}

/** Metodo que permite colocar un Objeto de la Clase Bebe en el mundo, dependiendo del numero de bebes que exitan en su momento en el mundo
 * recibe como parametro un Objeto de la clase Bebe, el cual sera colocado en el mundo
 */
public void colocaBebe(Bebe bb)
{
World wd=getWorld();

                wd.addObject(bb,bb.posx(),bb.posy());
    
}
/** Metodo que permite colocar un Objeto de la Clase Bebe2 en el mundo, dependiendo del numero de bebes que exitan en su momento en el mundo
 * recibe como parametro un Objeto de la clase Bebe2, el cual sera colocado en el mundo
 */
public void colocaBebe2(Bebe2 bb)
{
    World wd=getWorld();

                wd.addObject(bb,bb.posx(),bb.posy());
             

}

/**
 * Metodo que checa en donde debe colocar el bebe, dependiendo de la variable booleana que ha sido pasada como parametro
 * @param c es la variable booleana que dice cual es el siguiente bebe a poner en el mundo.
 */
public void ChecaPonerBebes(boolean c)
{
if(checaNumeroBebes()<=3&&numeroMaximoBebes>0)
          {
              if(!c)
              {
                        bb=new Bebe(50,5);
                        colocaBebe(bb);
                        yaPusoBebe=true;
                        colorB=bb.colorBebe();
                        if(numeroBebes==0)
                        primero=true;
                        else
                        primero=false;
                        numeroBebes++;
                        numeroMaximoBebes--;
                        cual=true;
                    }
                    else {
                        bb2=new Bebe2(25,5);
                        colocaBebe2(bb2);
                        yaPusoBebe=true;
                        colorB2=bb2.colorBebe();
                        if(numeroBebes==0)
                        primero=true;
                        else
                        primero=false;
                        numeroBebes++;
                        numeroMaximoBebes--;
                        cual=false;
                    }
                     
        }
        else
        if(yaPerdio())
        perder();
    }

/**Metodo que recibe como parmetro el mundo obtenido, coloca en el una vida para que el jugador pueda adquirirla siempre y cuando no la haya
 * puesto y que las vidas sean iguales a 1, son las dos condiciones que hay que cumplir para poder poner esta vida extra como ayuda.
 */
public void colocaVidaExtra(World wd)
{
 if(vidas==1&&!yaPusoVida)
          {
          wd.addObject(c,130,30);
          yaPusoVida=true;
        }
    }
    
/** funcin que permite cambiar la imagen de la Cigea, dependiendo del color del beb que agarr
    regresa boolean que representa si ya lo agarro la Cigea para poder quitarlo del Mundo
    @ boolean res=false inicializa el valor que regresar en false
    @param color corresponde al identificador de la imagen a sacar del archivo y poder cambiar la imagen en la ciguena.
 */
public boolean cambiaImagen(int color)
{
    boolean res=false;
    switch(color)
                {
                    case 0:    
                            super.cambiaImagen("ciguenaa",".png",8);
                            volteado=false;
                            //if(numeroBebes>0)
                            numeroBebes--;
                            res=yaAgarreBebe=true;
                            yaDejeBebe=false;
                            break;
                    case 1:
                            super.cambiaImagen("ciguenam",".png",8);
                            volteado=false;
                            //if(numeroBebes>0)
                            numeroBebes--;
                            res=yaAgarreBebe=true;
                            yaDejeBebe=false;
                            break;
                    case 2:
                            super.cambiaImagen("ciguenaro",".png",8);
                            volteado=false;
                            //if(numeroBebes>0)
                            numeroBebes--;
                            res=yaAgarreBebe=true;
                            yaDejeBebe=false;
                            break;
                     case 3:
                            super.cambiaImagen("ciguenar",".png",8);
                            volteado=false;
                            //if(numeroBebes>0)
                            numeroBebes--;
                            res=yaAgarreBebe=true;
                            yaDejeBebe=false;
                            break;
                     case 4:
                            super.cambiaImagen("ciguenav",".png",8);
                            volteado=false;
                            //if(numeroBebes>0)
                            numeroBebes--;
                            res=yaAgarreBebe=true;
                            yaDejeBebe=false;
                            break;
                            

                        }
                       
                        return res;
            }

/**
*metodo que permite restar los puntos siempre y cuando alcancen los puntos, es decir, si el resultado de la resta es negativo, lo valida y solo
*queda en cero.
*@param res es el numero entero a restar a los puntos.
         */
public void restar(int res)
{
if((puntos-res>=0))
puntos=puntos-res;
else
puntos=0;

}

/**
 * metodo importante para poder checar la tecla presionada por el usuario para poder hacer el correcto movimiento de la ciguena.
 * @param wd es del tipo World, el cual se le pasa el mundo actual.
 */
public void movimientos(World wd)
{
if(Greenfoot.isKeyDown("left"))
          {
              if(getX()>=8)
              {
            
              if(!volteado)
               super.enEspejo();
               volteado=true;
               super.act();
               List checaNubecitas=wd.getObjectsAt(getX()-12,getY(),Nube.class);
               if(checaNubecitas.isEmpty())
               {
               setLocation(getX()-3,getY());
                super.act();
            }
        }
              
            }
            if(Greenfoot.isKeyDown("right"))
            {
                if(getX()<=141)
                {
              if(volteado)
              super.enEspejo();
              volteado=false;
              List checaNubecitas=wd.getObjectsAt(getX()+12,getY(),Nube.class);
               if(checaNubecitas.isEmpty())
               {
              setLocation(getX()+3,getY());
              super.act();
            }
        }
            }
            if(Greenfoot.isKeyDown("up"))
            {
                if(getY()>=6)
                {
                List checaNubecitas=wd.getObjectsAt(getX(),getY()-8,Nube.class);
               if(checaNubecitas.isEmpty())
               {
                setLocation(getX(),getY()-3);
                super.act();
            }
        }
            }
             if(Greenfoot.isKeyDown("down"))
            {
                if(getY()<=77)
                {
                List checaNubecitas=wd.getObjectsAt(getX(),getY()+8,Nube.class);
               if(checaNubecitas.isEmpty())
               {
                setLocation(getX(),getY()+3);
                super.act();
            }
        }
            }

        }
 /**
  * metodo que permite saber si no terminado el juego, regresa un true si no ha terminado y un false si se encuentra en el
  * ultimo nivel.
  */
public boolean checaNivel()
{
  boolean res=false;
  if(nivel<3)
     res=true;
     return res;
}
/**
 * metodo que permite decirle al mundo a que nivel debe brincar ya que se ha terminado el juego.
 */
public void siguieneteNivel()
{
World wd=getWorld();
switch(nivel)
 {
   case 1:
          ((Mundo)getWorld()).segundoNivel(puntos);
           break;
   case 2:
          ((Mundo)getWorld()).tercerNivel(puntos);
           break;
  }
}
/**
 * metodo que permita agregar los objetos de la clase Casa en el mundo.
 */          
public void agregaCasas()
{
if(!yaPuseCasa)
{
World wd=getWorld();
int sp=15;

                c0 = new Casa(0);
                wd.addObject(c0,sp,97);
                nc0=c0.colorCasa();
         
                 c1 = new Casa(1);
                wd.addObject(c1,sp*3+2,97);
                nc1=c1.colorCasa();
                
                 c2 = new Casa(2);
                wd.addObject(c2,sp*5+2,97);
                nc2=c2.colorCasa();
     
                 c3 = new Casa(3);
                 wd.addObject(c3,sp*7+2,97);
                 nc3=c3.colorCasa();
    
                 c4 = new Casa(4);
                 wd.addObject(c4,sp*9,97);
                nc4=c4.colorCasa();
            
              yaPuseCasa=true;

            }
        }
/** 
 * Este metodo permite desplegar en pantalla las tres imagenes de las vidas al iniciar siempre el juego o un nivel.
 * @param wd es un objeto de la clase Worls que le permite saber como esta el mundo actualmente.
 */
public void agregaVidasFuera(World wd)
{
if(!vidasFuera)
         {
         wd.addObject(vd1,135,12);
         wd.addObject(vd2,141,12);
         wd.addObject(vd3,147,12);
         vidasFuera=true;
        }
}
/**
 * Este metodo permite saber si la ciguena fue intersectada por un Cuervo y si es asi, le resta vidas y puntos.
 */
public void siChocaCuervo()
{
    //Actor crow=getOneObjectAtOffset(0,0,Cuervo.class);
    Actor crow=getOneIntersectingObject(Cuervo.class);
    if(crow!=null)
         {
            restaVida();
            restar(100);
            pun.setText("SCORE: "+puntos);
    } 
}
/**
 * Este metodo nos realiza la tarea de quitar las imagenes que representan las vidas, dependiendo del caso y determinando validaciones
 */
public void remueveVidas()
{
World wd=getWorld();
if(vidasFuera)
            {
            if(vidas==2)
            wd.removeObject(vd3);
           
            if(vidas==1&&extra)
            wd.removeObject(vd4);
            else if(vidas==1)
             wd.removeObject(vd2);
            if(vidas==0)
            wd.removeObject(vd1);
            
        }
}
/**
 * permite saber si el usuario ha interseptado una vida extra, y suma las vidas y despliega una barra en el numero de vidas.
 */
public void siChocaVidaExtra()
{
    Actor vidaExtra=getOneIntersectingObject(Corazon.class);
    World wd=getWorld();
             if(vidaExtra!=null)
         {
             wd.removeObject(vidaExtra);
             vidas++;
             puntos=puntos+100;
             wd.addObject(vd4,129,12);
             pun.setText("SCORE: "+puntos);
            lifes.setText("LIFES:"+vidas);
            extra=true;
            }
}
/**
 * checa el numero de bebes existentes en el mundo y cambia de estado la bandera cual.
 */
public void revalida()
{
if(numeroBebes==2)
cual=!cual;
}
/**
 * resta una vida al usuario si este ha cometido un error, y atcualiza los marcadores.
 */
protected void restaVida()
{
            vidas--;
            //restar(100);
            pun.setText("SCORE: "+puntos);
            lifes.setText("LIFES:"+vidas);
            remueveVidas();
            setLocation(60,5);
}

    }

