import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * Write a description of class Resultado here.
 * 
 * @author Desconocido
 * @version (a version number or a date)
 */
public class Resultado  extends Actor
{
    public static final float FONT_SIZE = 48.0f;
    public static final int WIDTH = 400;
    public static final int HEIGHT = 300;
    
  
    
    public Resultado(int nivel,int puntos)
    {
        if(nivel!=0)
           makeImage(" NIVEL", "", nivel);
        if(nivel==4)
           makeImage(" SCORE ", "", puntos);
    }    
    
    public Resultado(String title, String title2)
    {
        makeImage(title,title2);
    }
    
    /**
     * Act - do whatever the Resultado wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
    }    
    
    
    private void makeImage(String title, String prefix, int nivel)
    {
      if(nivel!=0)
      {
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(25,25,25, 158));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(10, 10, 10, 158));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.GREEN);
        image.drawString(title, 120, 100);
        image.drawString(prefix + nivel, 190, 200);
        setImage(image);
      }
      
    }
    
    private void makeImage(String title, String prefix)
    {

        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);
        image.setColor(new Color(25,25,25, 158));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(10, 10, 10, 158));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.CYAN);
        image.drawString(title, 70, 100);
        image.drawString(prefix, 160, 200);
        setImage(image);

       
    }
    
        
    

}
